## dgit 3.9

=== debian/tests/control ===
Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, git-buildpackage

Tests: clone-reprepro downstream-gitless
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, reprepro

Tests: defdistro-dsd-clone-drs dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: gitattributes
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, bsdgames, man-db, git-man

Tests: defdistro-mirror mirror mirror-debnewgit mirror-private
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, rsync

Tests: build-modes-sbuild quilt-gbp-build-modes-sbuild
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, sbuild
Restrictions: x-dgit-schroot-build

Tests: spelling
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential
Restrictions: x-dgit-git-only

Tests: absurd-gitapply badcommit-rewrite build-modes build-modes-asplit build-modes-gbp-asplit clone-clogsigpipe clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject debpolicy-quilt-gbp defdistro-rpush defdistro-setup distropatches-reject drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast gbp-orig gitconfig import-dsc import-native import-nonnative import-tarbomb inarchivecopy mismatches-contents mismatches-dscchanges multisuite newtag-clone-nogit oldnewtagalt oldtag-clone-nogit orig-include-exclude orig-include-exclude-chkquery overwrite-chkclog overwrite-junk overwrite-splitbrains overwrite-version protocol-compat push-buildproductsdir push-newpackage push-nextdgit quilt quilt-gbp quilt-gbp-build-modes quilt-singlepatch quilt-splitbrains rpush tag-updates test-list-uptodate trustingpolicy-replay unrepresentable version-opt
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential

## dgit 3.10~bpo8+1

=== debian/changelog ===
dgit (3.10~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 17 Feb 2017 10:05:38 -0700

dgit (3.10) unstable; urgency=medium

  Bugfixes:
  * dgit: Copy several user.* settings from main tree git local config
    to dgit private workarea.  Closes:#853085.
  * dgit: Strip initial newline from Changes line from dpkg-parsechangelog
    so as to avoid blank line in commit messages.  Closes:#853093.
  * dgit: Do not fail when run with detached HEAD.  Closes:#853022.
  * dgit: Be much better about commas in maintainer changelog names.
    Closes:#852661.

  Test suite:
  * quilt-useremail: New test for user config copying (#853085).
  * lib-import-chk: Test that commits have smae authorship as appears in
    the changelog.  (Or, at least, the same authorship set.)
  * import-maintmangle: New test for changelog Maintainer mangling.

  Documentation:
  * Fix typos.  Closes:#853125.  [Nicholas D Steeves]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 06 Feb 2017 17:49:39 +0000

=== debian/control ===
Source: dgit
Section: devel
Priority: optional
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Standards-Version: 3.9.4.0
Build-Depends: debhelper (>= 9)
Testsuite: autopkgtest
Vcs-Git: git://git.chiark.greenend.org.uk/~ianmdlvl/dgit.git
Vcs-Browser: http://www.chiark.greenend.org.uk/ucgi/~ianmdlvl/git/dgit.git/

Package: dgit
Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
         ${misc:Depends}, git-buildpackage, liblist-moreutils-perl,
         coreutils (>= 8.23-1~) | realpath,
         libdigest-sha-perl, dput, curl, apt,
         libjson-perl, ca-certificates,
         libtext-iconv-perl, libtext-glob-perl
Recommends: ssh-client
Suggests: sbuild
Architecture: all
Description: git interoperability with the Debian archive
 dgit (with the associated infrastructure) makes it possible to
 treat the Debian archive as a git repository.
 .
 dgit push constructs uploads from git commits
 .
 dgit clone and dgit fetch construct git commits from uploads.

Package: dgit-infrastructure
Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
         libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,
         libwww-perl, libdpkg-perl
Recommends: dgit
Architecture: all
Priority: extra
Description: dgit server backend infrastructure
 This package contains tools which are useful for setting up a dgit
 git repository server.  You probably want dgit, the client package,
 instead of dgit-infrastructure.

=== debian/tests/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential
 Restrictions: x-dgit-git-only
 
-Tests: absurd-gitapply badcommit-rewrite build-modes build-modes-asplit build-modes-gbp-asplit clone-clogsigpipe clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject debpolicy-quilt-gbp defdistro-rpush defdistro-setup distropatches-reject drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast gbp-orig gitconfig import-dsc import-native import-nonnative import-tarbomb inarchivecopy mismatches-contents mismatches-dscchanges multisuite newtag-clone-nogit oldnewtagalt oldtag-clone-nogit orig-include-exclude orig-include-exclude-chkquery overwrite-chkclog overwrite-junk overwrite-splitbrains overwrite-version protocol-compat push-buildproductsdir push-newpackage push-nextdgit quilt quilt-gbp quilt-gbp-build-modes quilt-singlepatch quilt-splitbrains rpush tag-updates test-list-uptodate trustingpolicy-replay unrepresentable version-opt
+Tests: absurd-gitapply badcommit-rewrite build-modes build-modes-asplit build-modes-gbp-asplit clone-clogsigpipe clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject debpolicy-quilt-gbp defdistro-rpush defdistro-setup distropatches-reject drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast gbp-orig gitconfig import-dsc import-maintmangle import-native import-nonnative import-tarbomb inarchivecopy mismatches-contents mismatches-dscchanges multisuite newtag-clone-nogit oldnewtagalt oldtag-clone-nogit orig-include-exclude orig-include-exclude-chkquery overwrite-chkclog overwrite-junk overwrite-splitbrains overwrite-version protocol-compat push-buildproductsdir push-newpackage push-nextdgit quilt quilt-gbp quilt-gbp-build-modes quilt-singlepatch quilt-splitbrains quilt-useremail rpush tag-updates test-list-uptodate trustingpolicy-replay unrepresentable version-opt
 Tests-Directory: tests/tests
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential

## dgit 3.11~deb9u1

=== debian/changelog ===
dgit (3.11~deb9u1) stretch; urgency=high

  * Rebuild and upload to stretch.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 11 Jul 2017 09:28:15 +0100

dgit (3.11) unstable; urgency=high

  Important bugfixes to dgit:
  * Fix rpush+buildinfo: Transfer buildinfos for signing.  Closes:#867693.
  * Cope if the archive server sends an HTTP redirect,
    by passing -L to curl.  Closes:#867185,#867309.
  * Cope with newer git which hates --local outside a tree.  Closes:#865863.
  * rpush: Honour local git config from build host working tree.
  * Tolerate compressor terminating with SIGPIPE.  Closes:#857694.
  * Honour more pre-tree git config options in our private trees sharing
    the user's object store.  In particular, core.sharedRepository.
    Prompted by #867603.
  * Clone multisuite works even without --no-rm-on-error.  Closes:#867434.
  * Work if "git init" does not create $GIT/info.  Closes:#858054.
  * Actually understand foo,-security (!)  Closes:#867189.

  Important bugfixes to other components:
  * dgit-badcommit-fixup: Honour core.sharedRepository.   Closes:#867603.
  * infrastructure: Cope with new git-receive-pack which has
    quarantine feature: ie, work around #867702.

  Test suite:
  * Cope with git restricting ext:: protocols.
  * multisuite: Test clone without --rm-on-error.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 08 Jul 2017 22:40:15 +0100

## dgit 3.12

=== debian/changelog ===
dgit (3.12) unstable; urgency=high

  Important bugfixes to dgit:
  * Pass --no-renames to git diff-tree -z, avoiding potential trouble.
  * Defend against commit subject lines which would generate patches which
    look like series files, etc.  Involves adding .patch to all generated
    patch filenames.
  * dgit import: Defend against broken symlinks in ..
  * dgit import: Right error message for missing files in ..
  * dgit import: Avoid making broken symlinks in ..
  * quilt fixup: Tolerate deletion of executable files.
  * quilt fixup: Tolerate symlink creation (make patches).  Closes:#857382.

  Important bugfixes to other components:
  * dgit-repos-server: Do not reject commits with no author/committer
    email address (but still insist on date, and hence on the actual
    committer and author commit header fields).  Peter Green reports that
    eg 66c65d90db100435 in upstream linux.git is such a commit (and is
    accepted by github).  Closes:#863353.

  Test suite:
  * t-report-fail: print $PWD as part of failure message.
  * import-dsc: Test missing files, particularly in ..
  * run git gc on tests/worktrees/example_1.0.tar.
  * quilt fixup: Check we can delete files with funny modes
  * quilt fixup: Check that funny changes are represented properly

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Jul 2017 21:36:24 +0100

## dgit 4.3

=== Makefile ===
# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013-2016 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

INSTALL=install
INSTALL_DIR=$(INSTALL) -d
INSTALL_PROGRAM=$(INSTALL) -m 755
INSTALL_DATA=$(INSTALL) -m 644

prefix?=/usr/local

bindir=$(prefix)/bin
mandir=$(prefix)/share/man
perldir=$(prefix)/share/perl5
man1dir=$(mandir)/man1
man7dir=$(mandir)/man7
infraexamplesdir=$(prefix)/share/doc/dgit-infrastructure/examples
txtdocdir=$(prefix)/share/doc/dgit
absurddir=$(prefix)/share/dgit/absurd

PROGRAMS=dgit dgit-badcommit-fixup
MAN1PAGES=dgit.1

MAN7PAGES=dgit.7				\
	dgit-user.7 dgit-nmu-simple.7		\
	dgit-maint-native.7			\
	dgit-maint-merge.7 dgit-maint-gbp.7	\
	dgit-sponsorship.7

TXTDOCS=README.dsc-import
PERLMODULES=Debian/Dgit.pm
ABSURDITIES=git

INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch \
	dgit-repos-policy-debian dgit-repos-admin-debian \
	dgit-repos-policy-trusting dgit-mirror-rsync
INFRA_EXAMPLES=get-dm-txt ssh-wrap drs-cron-wrap get-suites
INFRA_PERLMODULES= \
	Debian/Dgit.pm \
	Debian/Dgit/Infra.pm \
	Debian/Dgit/Policy/Debian.pm

all:	$(MAN7PAGES) $(addprefix substituted/,$(PROGRAMS))

substituted/%:	%
	mkdir -p substituted
	perl -pe 's{\bundef\b}{'\''$(absurddir)'\''} if m/###substituted###/' \
		<$< >$@

install:	installdirs all
	$(INSTALL_PROGRAM) $(addprefix substituted/,$(PROGRAMS)) \
		$(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) $(addprefix absurd/,$(ABSURDITIES)) \
		$(DESTDIR)$(absurddir)
	$(INSTALL_DATA) $(MAN1PAGES) $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) $(MAN7PAGES) $(DESTDIR)$(man7dir)
	$(INSTALL_DATA) $(TXTDOCS) $(DESTDIR)$(txtdocdir)
	set -e; for m in $(PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

installdirs:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(man1dir) $(DESTDIR)$(man7dir) \
		$(DESTDIR)$(txtdocdir) $(DESTDIR)$(absurddir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))

install-infra:	installdirs-infra
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_PROGRAMS)) \
		$(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_EXAMPLES)) \
		$(DESTDIR)$(infraexamplesdir)
	set -e; for m in $(INFRA_PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

installdirs-infra:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(infraexamplesdir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(INFRA_PERLMODULES)))

check installcheck:

clean distclean mostlyclean maintainer-clean:
	rm -rf tests/tmp substituted
	set -e; for m in $(MAN7PAGES); do \
		test -e $$m.pod && rm -f $$m; \
	done

%.7: %.7.pod
	pod2man --section=7 --date="Debian Project" --center="dgit" \
		--name=$(subst .7,,$@) \
		$^ $@

%.view:	%
	man -l $*

=== tests/Makefile ===
# usage: tests/using-intree make -f tests/Makefile
# optionally setting
#   TESTSCRIPTS='tests/tests/foo tests/tests/bar')
#   DGIT_TEST_RETRY_COUNT=<a smallish integer>

TESTSCRIPTS ?= $(shell tests/enumerate-tests)
TESTNAMES := $(notdir $(TESTSCRIPTS))

all: $(foreach t,$(TESTNAMES),tests/tmp/$t.ok)
	@echo "ALL PASSED"

tests/tmp:
	mkdir -p $@

ifeq ($(DGIT_TEST_RETRY_COUNT),)

tests/tmp/%.ok: tests/tmp
	tests/tests/$* >tests/tmp/$*.log 2>&1

else

tests/tmp/%.ok: tests/tmp
	@for retry in $$( seq 1 $(DGIT_TEST_RETRY_COUNT) ); do		\
		echo "[$$retry] $*";					\
		tests/tests/$* >tests/tmp/$*.$$retry.log 2>&1;		\
		rc=$$?;							\
		if [ $$rc = 0 ]; then exit 0; fi;			\
		echo >&2 "[$$retry] $* TEST FAILED $$rc";		\
	done; exit $$rc

endif

=== debian/changelog ===
dgit (4.3) unstable; urgency=high

  Documentation improvements:
  * dgit(7): Discuss file executability.  Closes:#886444.
  * dgit(7): Discuss git-unrepresentable properties of source trees.
  * dgit-maint-merge(7): Don't suggest using debian/source/patch-header
    for 1.0 source format.  Closes:#887850.  [Sean Whitton]

  Bugfixes:
  * dgit archive-api-query: Avoid crashing due to lack of $isuite.
    This breaks the infrastructure.  Closes:#886592.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 25 Jan 2018 00:33:56 +0000

dgit (4.2) unstable; urgency=low

  * Upload dgit 4.x series to unstable.

  New features [Sean Whitton]:
  * New 'push-source' subcommand for source-only uploads.  Closes:#848931
  * When dgit builds a source package, such as in the 'build-source'
    subcommand, it now bypasses dpkg-buildpackage and invokes dpkg-source
    directly.  This avoids a _source.buildinfo file in the .changes, which
    doesn't make sense when using dgit.  See
    <https://lists.debian.org/debian-dpkg/2017/06/msg00005.html>.

  Documentation improvements:
  * dgit(1): Add a bit more rationale (polemic, even).  Closes:#874221.
  * Recommend mk-build-deps rather than apt-get build-dep.
    Suggestion from Nikolaus Rath.  Closes:#863361.
  * dgit-maint-merge(7): many updates.  [Sean Whitton]
    Closes:#864873,#878433.
  * dgit-*(7): Mention first upload trick.  [Andrew Shadura,
    Sean Whitton]  Closes:#856402.

  Minor fixes:
  * When source discrepancy involves file mode changes, report them
    specially.  Closes:#886442.
  * In split brain mode, with unexpected diffs, print dgit view
    commitid in suggested diff rune.  (HEAD is wrong.)  Closes:#886443.
  * Fix message about missing quilt cache entry to refer to
    HEAD rather than tree, since dgit needs a commit.  Closes:#884646.
  * Fix grammar error in 4.1 changelog entry. [Sean Whitton]
  * Remove some whitespace "errors". [Sean Whitton]

  Packaging:
  * Remove dependency alternative on realpath (package last existed in
    Debian wheezy).  Closes:#877552.

  Test suite:
  * dpkgsourceignores-docs: Correct restriction (so autopkgtest
    won't try to run it).
  * Additional workarounds for gnupg races (#868550) including
    retrying each individual test once, and more sophisticated
    wrapper for gpg (with locking and, sometimes saves stdin).
  * oldnewtagalt: Fix regression when running outside git tree,
    introduced in 4.1.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 07 Jan 2018 21:45:29 +0000

dgit (3.13) unstable; urgency=high

  Important bugfixes to dgit:
  * Add missing `use' for Dpkg::Compression et al.
    Thanks to report from Didier 'OdyX' Raboud.  (Closes:#879526.)

  Test suite:
  * Add missing `chiark-utils-bin' to Test-Depends.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 22 Oct 2017 17:51:12 +0100

dgit (4.1) experimental; urgency=medium

  Important improvements to dgit:
  * Support for `git worktree' worktrees.  There may still be
    bugs; the tests for this are not very comprehensive.  And
    worktrees on different filesystems may not work; that's a
    matter for the future.  Closes:#868515.
  * Change the dpkg-source -i argument to exclude exactly the right
    set of things.  (Sadly this is not a simple rune.)

  Other improvements to dgit:
  * New print-dpkg-source-ignores option to print the big rune
    you need to pass to dpkg-source to make it work exactly right.
  * Properly shell-quote the --git-builder argument to gbp.

  Documentation:
  * dgit-user(7): Provide information about how to use sbuild.
    Quite ugly due to #868527.  Closes:#868526.
  * dgit-user(7): Fixed example rune to use curl (which prints
    to stdout, as the rune expects).  [reported by Simon Tatham]

  Minor improvements:
  * Do not leave many clog-* files in .git/dgit.

  Internal changes:
  * using-these: New script to help with ad-hoc-testing.
  * Refactoring in preparation for push-source [Sean Whitton].

  Test suite:
  * sbuild-gitish: New test case to check running sbuild from git
  * Work around gnupg agent connection races by having our stunt
    gpg wrapper simply try running gpg again, once, if it exits 2.
    This does not fully suppress the bug but it does significantly reduce
    the probability.
  * Other tests for new features.
  * Various refactoring.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 14 Aug 2017 09:31:03 +0100

dgit (4.0) experimental; urgency=low

  * dgit: --deliberately-not-fast-forward works properly in
    split view quilt modes (suppressing the pseudomerge).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 12 Feb 2017 22:22:31 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Package: dgit
 Depends: perl, libwww-perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
          ${misc:Depends}, git-buildpackage, liblist-moreutils-perl,
-         coreutils (>= 8.23-1~) | realpath,
+         coreutils (>= 8.23-1~),
          libdigest-sha-perl, dput, curl, apt,
          libjson-perl, ca-certificates,
          libtext-iconv-perl, libtext-glob-perl

=== debian/rules ===
#!/usr/bin/make -f

# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013-2016 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

export prefix=/usr

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol
	set -e; \
	 cd debian/dgit; \
	 v=$$(perl -ne 'print if s/^version:\s+//i' DEBIAN/control); \
	 perl -i -pe "s/UNRELEASED/$$v/g if m/###substituted###/" usr/bin/dgit

globalperl=/usr/share/perl5
infraperl=/usr/share/dgit/infra/perl5

override_dh_auto_install:
	make install prefix=/usr DESTDIR=debian/dgit
	make install-infra prefix=/usr DESTDIR=debian/dgit-infrastructure \
		perldir=$(infraperl)
#	# Most of the Perl modules in dgit-infrastructure live in
#	# $(infraperl).  The exception is Debian::Dgit::Infra, which
#	# lives in $(globalperl) and adds $(infraperl) to @INC.
	set -ex; \
	 base=debian/dgit-infrastructure; \
	 mod=Debian/Dgit/Infra.pm; \
	 src=$${base}$(infraperl)/$${mod}; \
	 dst=$${base}$(globalperl)/$${mod}; \
	 mkdir -p $${dst%/*}; \
	 mv -f $$src $$dst; \
	 perl -i -p -e 'next unless m/###substituted###/;' \
		-e 'next unless s/^# (?=unshift \@INC,)//;' \
		-e 'die unless s{q\{\S+\}}{q{$(infraperl)}};' \
		 $$dst

debian/tests/control: tests/enumerate-tests debian/tests/control.in
	$< gencontrol >$@.new && mv -f $@.new $@

debian/tests/control: tests/lib-core tests/lib-restricts
debian/tests/control: tests/tests $(wildcard tests/tests/*[^~#])

=== debian/tests/control ===
Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, git-buildpackage

Tests: clone-reprepro downstream-gitless
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, reprepro

Tests: dpkgsourceignores-docs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin
Restrictions: x-dgit-intree-only

Tests: defdistro-dsd-clone-drs dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: gitattributes
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bsdgames, man-db, git-man

Tests: defdistro-mirror mirror mirror-debnewgit mirror-private
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, rsync

Tests: build-modes-sbuild quilt-gbp-build-modes-sbuild
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, sbuild
Restrictions: x-dgit-schroot-build

Tests: sbuild-gitish
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, sbuild, man-db
Restrictions: x-dgit-schroot-build

Tests: spelling
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin
Restrictions: x-dgit-git-only

Tests: absurd-gitapply badcommit-rewrite build-modes build-modes-asplit build-modes-gbp-asplit clone-clogsigpipe clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject debpolicy-quilt-gbp defdistro-rpush defdistro-setup distropatches-reject dpkgsourceignores-correct drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast gbp-orig gitconfig gitworktree import-dsc import-maintmangle import-native import-nonnative import-tarbomb inarchivecopy mismatches-contents mismatches-dscchanges multisuite newtag-clone-nogit oldnewtagalt oldtag-clone-nogit orig-include-exclude orig-include-exclude-chkquery overwrite-chkclog overwrite-junk overwrite-splitbrains overwrite-version protocol-compat push-buildproductsdir push-newpackage push-nextdgit push-source push-source-with-changes quilt quilt-gbp quilt-gbp-build-modes quilt-singlepatch quilt-splitbrains quilt-useremail rpush tag-updates test-list-uptodate trustingpolicy-replay unrepresentable version-opt
Tests-Directory: tests/tests

## dgit 5.2~bpo9+1

=== Makefile ===
--- 
+++ 
@@ -27,6 +27,7 @@
 mandir=$(prefix)/share/man
 perldir=$(prefix)/share/perl5
 man1dir=$(mandir)/man1
+man5dir=$(mandir)/man5
 man7dir=$(mandir)/man7
 infraexamplesdir=$(prefix)/share/doc/dgit-infrastructure/examples
 txtdocdir=$(prefix)/share/doc/dgit
@@ -39,11 +40,20 @@
 	dgit-user.7 dgit-nmu-simple.7		\
 	dgit-maint-native.7			\
 	dgit-maint-merge.7 dgit-maint-gbp.7	\
+	dgit-maint-debrebase.7                  \
 	dgit-sponsorship.7
 
 TXTDOCS=README.dsc-import
-PERLMODULES=Debian/Dgit.pm
+PERLMODULES=Debian/Dgit.pm Debian/Dgit/ExitStatus.pm
 ABSURDITIES=git
+
+GDR_PROGRAMS=git-debrebase
+GDR_PERLMODULES= \
+	Debian/Dgit.pm \
+	Debian/Dgit/GDR.pm \
+	Debian/Dgit/ExitStatus.pm
+GDR_MAN1PAGES=git-debrebase.1
+GDR_MAN5PAGES=git-debrebase.5
 
 INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch \
 	dgit-repos-policy-debian dgit-repos-admin-debian \
@@ -54,7 +64,10 @@
 	Debian/Dgit/Infra.pm \
 	Debian/Dgit/Policy/Debian.pm
 
-all:	$(MAN7PAGES) $(addprefix substituted/,$(PROGRAMS))
+MANPAGES=$(MAN1PAGES) $(MAN5PAGES) $(MAN7PAGES) \
+	$(GDR_MAN1PAGES) $(GDR_MAN5PAGES)
+
+all:	$(MANPAGES) $(addprefix substituted/,$(PROGRAMS))
 
 substituted/%:	%
 	mkdir -p substituted
@@ -75,9 +88,18 @@
 
 installdirs:
 	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
-		$(DESTDIR)$(man1dir) $(DESTDIR)$(man7dir) \
+		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
+		$(DESTDIR)$(man7dir) \
 		$(DESTDIR)$(txtdocdir) $(DESTDIR)$(absurddir) \
 		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))
+
+install-gdr:	installdirs-gdr
+	$(INSTALL_PROGRAM) $(GDR_PROGRAMS) $(DESTDIR)$(bindir)
+	$(INSTALL_DATA) $(GDR_MAN1PAGES) $(DESTDIR)$(man1dir)
+	$(INSTALL_DATA) $(GDR_MAN5PAGES) $(DESTDIR)$(man5dir)
+	set -e; for m in $(GDR_PERLMODULES); do \
+		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
+	done
 
 install-infra:	installdirs-infra
 	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_PROGRAMS)) \
@@ -88,6 +110,11 @@
 		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
 	done
 
+installdirs-gdr:
+	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
+		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
+		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(GDR_PERLMODULES)))
+
 installdirs-infra:
 	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(infraexamplesdir) \
 		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(INFRA_PERLMODULES)))
@@ -96,7 +123,7 @@
 
 clean distclean mostlyclean maintainer-clean:
 	rm -rf tests/tmp substituted
-	set -e; for m in $(MAN7PAGES); do \
+	set -e; for m in $(MANPAGES); do \
 		test -e $$m.pod && rm -f $$m; \
 	done
 
@@ -105,5 +132,10 @@
 		--name=$(subst .7,,$@) \
 		$^ $@
 
+git-debrebase.%: git-debrebase.%.pod
+	pod2man --section=$* --date="Debian Project" --center="git-debrebase" \
+		--name=$(subst .$*,,$@) \
+		$^ $@
+
 %.view:	%
 	man -l $*

=== debian/changelog ===
dgit (5.2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Restore missing comma in Depends: field.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 28 Jun 2018 12:55:02 +0100

dgit (5.2) unstable; urgency=medium

  dgit bugfixes:
  * When all Debian changes vanish with single-debian-patch,
    do not fail to commit the patch queue removal.  Closes:#877036.
  * When build fails because the network is offline, mention
    that this is because --since-version was not specified.
    Closes:#883340.
  * When quilt fixup fails because of discrepancies, print a
    git diff rune which will show them.  Closes:#865446.
  * When fetch or push wants git fetch (other than in a situation where it
    happes to be a noop) but --dry-run was specified, fail with an
    explanation, rather than looping with a false coplaint about git
    fetch.  Closes:#871317.
  * --overwrite now no longer crashes if there is nothing to overwrite
    (eg, when used with --new).  Instead, it is simply ignored, as it is
    ignored in situations where the push is fast forward.  Closes:#863576.

  dgit/git-debrebase interop bugfixes:
  * git-debrebase interop: Add a missing debugcmd debugging print.
  * git-debrebase interop: Actually tolerate git-debrebase make-patches
    exiting with status 7.

  dgit vcs-git handling improvements:
  * Provide `update-vcs-git' subcommand, for creating and adjusting the
    vcs-git remote url.  Useful for transition from alioth to salsa.
    Closes:#902006.
  * Print a warning to stderr on `dgit fetch sid', if your vcs-git
    remote url disagrees with what's in sid's .dsc.

  documentation:
  * dgit(1): Mention under `dgit build' that it uses the network.
  * dgit(1): Clarify that --overwrite does nothing if not needed.
    Closes:#863578.
  * dgit-user(7): Recommend sbuild-debian-developer-setup.
    [ Sean Whitton. ]  Closes:895779.

  test suite:
  * Use nproc(1) rather than Sys::CPU.  This is more portable and does not
    depend on libsys-cpu-perl being installed.  Closes:888496.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 24 Jun 2018 23:33:28 +0100

dgit (5.1) unstable; urgency=medium

  dgit gitattributes handling:
  * Squash the working-tree-encoding attribute too.
  * Update an existing `dgit-defuse-attrs' macro in .git/info/attributes.
  * Test the working-tree-encoding attribute squashing properly.
    Closes:#901900.

  git-debrebase fixes:
  * new-upstream: fix (this time for sure) ff check handling
    of multi-piece upstreams.
  * Suppress gbp pq export output, except in case of error.
    Closes:#901809.
  * Manpages: Fix typos and etc.
  * Fix a typo in the package description.

  Test suite:
  * Triger ci.debian.net autopkgtests on: gnupg diffutils patch.
    (A dummy test is used to add to Testsuite-Triggers.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 20 Jun 2018 23:20:57 +0100

dgit (5.0) unstable; urgency=low

  Major new facility:
  * git-debrebase, a new git workflow tool, in its own package.
  * dgit will now, when appropriate, check if it should call
    git-debrebase.

  [ Thanks to Sean Whitton for much useful input, and for
     dgit-maint-debrebase(7). ]

  dgit bugfixes:
  * Fix the exit status of programs in dgit.deb, to avoid the Perl
    misfeature which sometimes copies $! to the exit status.
  * When checking that the tree is clean, check the git index too.
  * In quilt_fixup_multipatch, work around git checkout paths
    not deleting files.  (Hypothetical bug AFAIAA.)
  * Respect --quilt=nofix even if single-debian-patch.

  dgit minor fixes:
  * "confess" when we die due to a warning, rather than symply dieing.

  Internal changes:
  * Move $playground global to dgit.
  * Break git_get_symref and $extra_orig_namepart_re out into Dgit.pm.
  * Changes to support git-debrebase.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 18 Jun 2018 00:29:44 +0100

dgit (4.4) unstable; urgency=high

  Test suite bugfix:
  * Use full key hash rather than short keyid.  Closes:#896653.
    [ report: Paul Gevers; fix: Chris Lamb ]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 23 Apr 2018 13:18:51 +0100

dgit (4.3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 27 Jan 2018 09:13:46 -0700

dgit (4.2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 18 Jan 2018 17:30:23 -0700

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,15 @@
  .
  dgit clone and dgit fetch construct git commits from uploads.
 
+Package: git-debrebase
+Depends: perl, git-core, libdpkg-perl, libfile-fnmatch-perl,
+         ${misc:Depends}
+Recommends: dgit, git-buildpackage
+Architecture: all
+Description: rebasing git workflow tool for Debian packaging
+ git-debrebase is a tool for representing in git, and manipulating,
+ Debian packages based on upstream source code.
+
 Package: dgit-infrastructure
 Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
          libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,

=== debian/tests/control ===
--- 
+++ 
@@ -16,9 +16,22 @@
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin
 Restrictions: x-dgit-intree-only x-dgit-git-only
 
+Tests: gdr-diverge-nmu gdr-diverge-nmu-dgit gdr-edits gdr-import-dgit gdr-makepatches7 gdr-subcommands
+Tests-Directory: tests/tests
+Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, git-debrebase, git-buildpackage, faketime
+
+Tests: gdr-newupstream gdr-viagit
+Tests-Directory: tests/tests
+Depends: chiark-utils-bin, git-debrebase, git-buildpackage, faketime
+
 Tests: gitattributes
 Tests-Directory: tests/tests
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bsdgames, man-db, git-man
+
+Tests: hint-testsuite-triggers
+Tests-Directory: tests/tests
+Depends: gnupg, patch, diffutils
+Restrictions: hint-testsuite-triggers
 
 Tests: defdistro-mirror mirror mirror-debnewgit mirror-private
 Tests-Directory: tests/tests
@@ -39,5 +52,3 @@
 Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin
 Restrictions: x-dgit-git-only
 
-Tests: absurd-gitapply badcommit-rewrite build-modes build-modes-asplit build-modes-gbp-asplit clone-clogsigpipe clone-gitnosuite clone-nogit debpolicy-dbretry debpolicy-newreject debpolicy-quilt-gbp defdistro-rpush defdistro-setup distropatches-reject dpkgsourceignores-correct drs-clone-nogit drs-push-masterupdate drs-push-rejects dsd-clone-nogit dsd-divert fetch-localgitonly fetch-somegit-notlast gbp-orig gitconfig gitworktree import-dsc import-maintmangle import-native import-nonnative import-tarbomb inarchivecopy mismatches-contents mismatches-dscchanges multisuite newtag-clone-nogit oldnewtagalt oldtag-clone-nogit orig-include-exclude orig-include-exclude-chkquery overwrite-chkclog overwrite-junk overwrite-splitbrains overwrite-version protocol-compat push-buildproductsdir push-newpackage push-nextdgit push-source push-source-with-changes quilt quilt-gbp quilt-gbp-build-modes quilt-singlepatch quilt-splitbrains quilt-useremail rpush tag-updates test-list-uptodate trustingpolicy-replay unrepresentable version-opt
-Tests-Directory: tests/tests

## dgit 6.2~bpo9+1

=== Makefile ===
--- 
+++ 
@@ -41,6 +41,7 @@
 	dgit-maint-native.7			\
 	dgit-maint-merge.7 dgit-maint-gbp.7	\
 	dgit-maint-debrebase.7                  \
+	dgit-downstream-dsc.7			\
 	dgit-sponsorship.7
 
 TXTDOCS=README.dsc-import
@@ -119,6 +120,9 @@
 	$(INSTALL_DIR) $(DESTDIR)$(bindir) $(DESTDIR)$(infraexamplesdir) \
 		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(INFRA_PERLMODULES)))
 
+list-manpages:
+	@echo $(MANPAGES)
+
 check installcheck:
 
 clean distclean mostlyclean maintainer-clean:

=== tests/Makefile ===
--- 
+++ 
@@ -7,19 +7,12 @@
 TESTNAMES := $(notdir $(TESTSCRIPTS))
 
 all: $(foreach t,$(TESTNAMES),tests/tmp/$t.ok)
-	@echo "ALL PASSED"
+	@echo "ALL PASSED$${DGIT_TESTS_PROGRESSIVE+ AT SOME POINT}"
 
-tests/tmp:
-	mkdir -p $@
-
+tests/tmp/%.ok:
 ifeq ($(DGIT_TEST_RETRY_COUNT),)
-
-tests/tmp/%.ok: tests/tmp
 	tests/tests/$* >tests/tmp/$*.log 2>&1
-
 else
-
-tests/tmp/%.ok: tests/tmp
 	@for retry in $$( seq 1 $(DGIT_TEST_RETRY_COUNT) ); do		\
 		echo "[$$retry] $*";					\
 		tests/tests/$* >tests/tmp/$*.$$retry.log 2>&1;		\
@@ -27,5 +20,5 @@
 		if [ $$rc = 0 ]; then exit 0; fi;			\
 		echo >&2 "[$$retry] $* TEST FAILED $$rc";		\
 	done; exit $$rc
-
 endif
+	@touch $@

=== debian/changelog ===
dgit (6.2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 31 Jul 2018 14:05:03 +0800

dgit (6.2) unstable; urgency=medium

  * dgit(1): Improve and correct --build-products-dir description.
  * dgit: Minor code cleanup.
  * dgit build: Warn if --build-products-dir is not `..'.  Closes:#904859.
  * test suite: Test dgit import-dsc --build-products-dir.

  [Sean Whitton]
  * manpages: alioth->salsa
  * manpages: add references to pbuilder and cowbuilder
  * dgit-maint-gbp(7): discuss dgit.default.build-products-dir
  * dgit-maint-gbp(7): update references to --*-dirty
  * dgit-sponsorship(7): add references to push-source
  * dgit-maint-debrebase(7): fix command to just launder

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 29 Jul 2018 12:57:26 +0100

dgit (6.1) unstable; urgency=medium

  New feature:
  * 'pbuilder' and 'cowbuilder' subcommands (Closes: #844125).
    - Suggest sbuild | pbuilder | cowbuilder.

  Minor fixes:
  * Fix an error message to refer to the build products dir instead of
    just the parent directory.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 28 Jul 2018 20:14:23 +0800

dgit (6.0) unstable; urgency=medium

  New features [Sean Whitton]:
  * Introduce dgit.default.build-products-dir git configuration key.
    Closes:#857316.
  * Die earlier, and with a more helpful message, if the user tries to
    include dirty changes when building a source package in split brain
    mode.

  dgit behavioural changes:
  * dgit: Always build the source package ourselves, rather than
    sometimes leaving that to the builder command.  dgit will now
    usually generate *_multi.changes rather than *_$arch.changes.
  * dgit: Build source packages in a private directory, except when
    the user passes --include-dirty [Sean Whitton].
    - dgit push-source no longer cleans the tree [Sean Whitton].
  * dgit: Rename --ignore-dirty to --include-dirty (leaving the old
    name supported as a deprecated alias).

  Test suite improvements:
  * test suite: unset VISUAL, which interferes.  Closes:#904308.
  * Honour DGIT_SCHROOT_CHROOT to set the schroot to use for the sbuild
    tests.
  * Support tests/run-all --progressive.
  * Drop now-obsolete *-asplit tests.

  Other improvements:
  * apt-get method: when apt does not update release files,
    unconditionally print hint about noatime.  Closes:#851873.
  * messages: Be a lot more friendly about NEW in particular,
    and also add a couple of `please's.  Closes:#904448.
  * Make --build-products-dir (and the new config key) actually work.
    Closes:#863582.  [ Ian and Sean. ] 
  * dgit: Many important internal rearrangemnts relating to source
    package production and building.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 26 Jul 2018 14:43:47 +0100

dgit (5.10~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 19 Jul 2018 01:09:21 +0800

dgit (5.10) unstable; urgency=medium
 
  * Merge the experimental branch.
  * test suite: Drop a couple of useless test log output lines.
  * infrastructure: Run git gc --auto before mirroring.  Closes:#841414.
 
 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 14 Jul 2018 18:07:02 +0100
 

dgit (5.9+exp4) experimental; urgency=medium

  * test suite: Use  dch -r -D sid ''  not  dch -r sid.  Closes:#903441.
  * test suite: Save a tarball of much of the working area of each test
    in $AUTOPKGTEST_ARTIFACTS.
  * Separate changelog entries for the following test attempts
    in experimental have been elided:
      dgit (5.9+exp3) experimental; urgency=medium
      dgit (5.9+exp2) experimental; urgency=medium
      dgit (5.9+exp1) experimental; urgency=medium

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 12 Jul 2018 13:45:07 +0100

dgit (5.9) unstable; urgency=medium

  * git-debrebase convert-from-gbp: Look for dgit-generated tags so we can
    usually make the new branch ff of the dgit view.  Closes:#903132.
  * git-debrebase convert-from-gbp: Check that the result will not
    count as having diverged.  This will usually turn failures to make
    the ff pseudomerge into -fdiverged.  Related to #903132.
  * git-debrebase, Dgit.pm, git: some internal reorganisation to
    support git-debrebase changes.
  * dgit-downstream-dsc(7): New manpage.  Closes:#842643,#851194.
  * git-debrebase(5): Document best gitk options.  Closes:#901927.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 12 Jul 2018 13:37:12 +0100

dgit (5.8~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 12 Jul 2018 08:33:22 +0100

dgit (5.8) unstable; urgency=medium

  Bugfixes:
  * dgit, git-debrebase: Properly make patches even if an awkward
    .gitignore ignores the things in debian/patches.  Closes:#903130.
  * git-debrebase status: Fix commit reporting.  Closes:903131.
  * git-debrebase new-upstream: Add a -1 revision if the user
    didn't supply one.  Closes:#903127.
  * git-debrebase: Improve grammar if one blocking snag.
  * dgit(1): Unscramble push[-source] descriptions.  Closes:#903116.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 08 Jul 2018 11:42:41 +0100

dgit (5.7) unstable; urgency=medium

  New feature:
  * dgit checkout: new subcommand.  Closes:#878443.
  * dgit: Check that entirely-new uploads to Debian are not
    source-only-uploads, as those are REJECTed.  Closes:#801435.

  Bugfixes:
  * dgit(7): Mention git-debrebase and gbp pq alongside git-dpm,
    in the comment about handling patch stacks.
  * dgit update-vcs-git: Honour --package properly.
  * test suite: Always pass LC_COLLATE=C to sort(1).  Closes:#903006.
  * test suite: Fix trustingpolicy-replay & dput-ng.  Closes:#903007.
  * test suite: Test dput-ng compatibility.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 05 Jul 2018 15:02:21 +0100



=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
          libjson-perl, ca-certificates,
          libtext-iconv-perl, libtext-glob-perl
 Recommends: ssh-client
-Suggests: sbuild
+Suggests: sbuild | pbuilder | cowbuilder
 Architecture: all
 Description: git interoperability with the Debian archive
  dgit (with the associated infrastructure) makes it possible to

=== debian/rules ===
--- 
+++ 
@@ -31,25 +31,33 @@
 	 perl -i -pe "s/UNRELEASED/$$v/g if m/###substituted###/" usr/bin/dgit
 
 globalperl=/usr/share/perl5
-infraperl=/usr/share/dgit/infra/perl5
 
-override_dh_auto_install:
+override_dh_auto_install: specpkg_install_gdr specpkg_install_infra
 	make install prefix=/usr DESTDIR=debian/dgit
-	make install-infra prefix=/usr DESTDIR=debian/dgit-infrastructure \
-		perldir=$(infraperl)
-#	# Most of the Perl modules in dgit-infrastructure live in
-#	# $(infraperl).  The exception is Debian::Dgit::Infra, which
-#	# lives in $(globalperl) and adds $(infraperl) to @INC.
+
+specpkg_install_gdr: p=git-debrebase
+specpkg_install_gdr: pm=GDR
+
+specpkg_install_infra: p=dgit-infrastructure
+specpkg_install_infra: pm=Infra
+
+specpkg_install_%: tok=$*
+specpkg_install_%: specperl=/usr/share/dgit/$(tok)/perl5
+specpkg_install_%:
+	make install-$(tok) prefix=/usr DESTDIR=debian/$(p) perldir=$(specperl)
+#	# Most of the Perl modules in this package live in
+#	# $(specperl).  The exception is Debian::Dgit::Infra, which
+#	# lives in $(globalperl) and adds $(specperl) to @INC.
 	set -ex; \
-	 base=debian/dgit-infrastructure; \
-	 mod=Debian/Dgit/Infra.pm; \
-	 src=$${base}$(infraperl)/$${mod}; \
+	 base=debian/$(p); \
+	 mod=Debian/Dgit/$(pm).pm; \
+	 src=$${base}$(specperl)/$${mod}; \
 	 dst=$${base}$(globalperl)/$${mod}; \
 	 mkdir -p $${dst%/*}; \
 	 mv -f $$src $$dst; \
 	 perl -i -p -e 'next unless m/###substituted###/;' \
 		-e 'next unless s/^# (?=unshift \@INC,)//;' \
-		-e 'die unless s{q\{\S+\}}{q{$(infraperl)}};' \
+		-e 'die unless s{q\{\S+\}}{q{$(specperl)}};' \
 		 $$dst
 
 debian/tests/control: tests/enumerate-tests debian/tests/control.in

=== debian/tests/control ===
Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, git-buildpackage

Tests: clone-reprepro downstream-gitless
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, reprepro

Tests: dpkgsourceignores-docs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc
Restrictions: x-dgit-intree-only

Tests: defdistro-dsd-clone-drs dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: gdr-diverge-nmu gdr-diverge-nmu-dgit gdr-edits gdr-import-dgit gdr-makepatches7 gdr-subcommands
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, git-debrebase, git-buildpackage, faketime

Tests: gdr-newupstream gdr-viagit
Tests-Directory: tests/tests
Depends: chiark-utils-bin, git-debrebase, git-buildpackage, faketime

Tests: gitattributes
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, bsdgames, man-db, git-man

Tests: hint-testsuite-triggers
Tests-Directory: tests/tests
Depends: gnupg, patch, diffutils
Restrictions: hint-testsuite-triggers

Tests: manpages-format
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, man-db, make, groff, git-debrebase

Tests: defdistro-mirror mirror mirror-debnewgit mirror-private
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, rsync

Tests: build-modes-sbuild quilt-gbp-build-modes-sbuild
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, sbuild
Restrictions: x-dgit-schroot-build

Tests: sbuild-gitish
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, sbuild, man-db
Restrictions: x-dgit-schroot-build

Tests: spelling
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc
Restrictions: x-dgit-git-only

Tests: trustingpolicy-replay
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, dput-ng
